<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefundFailureReasonType StructType
 * Meta informations extracted from the WSDL
 * - documentation: This type is deprecated.
 * @subpackage Structs
 */
class RefundFailureReasonType extends AbstractStructBase
{
    /**
     * The RefundFailureCode
     * Meta informations extracted from the WSDL
     * - documentation: This field is deprecated.
     * - minOccurs: 0
     * @var string
     */
    public $RefundFailureCode;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for RefundFailureReasonType
     * @uses RefundFailureReasonType::setRefundFailureCode()
     * @uses RefundFailureReasonType::setAny()
     * @param string $refundFailureCode
     * @param \DOMDocument $any
     */
    public function __construct($refundFailureCode = null, \DOMDocument $any = null)
    {
        $this
            ->setRefundFailureCode($refundFailureCode)
            ->setAny($any);
    }
    /**
     * Get RefundFailureCode value
     * @return string|null
     */
    public function getRefundFailureCode()
    {
        return $this->RefundFailureCode;
    }
    /**
     * Set RefundFailureCode value
     * @uses \EnumType\RefundFailureCodeType::valueIsValid()
     * @uses \EnumType\RefundFailureCodeType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $refundFailureCode
     * @return \StructType\RefundFailureReasonType
     */
    public function setRefundFailureCode($refundFailureCode = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\RefundFailureCodeType::valueIsValid($refundFailureCode)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $refundFailureCode, implode(', ', \EnumType\RefundFailureCodeType::getValidValues())), __LINE__);
        }
        $this->RefundFailureCode = $refundFailureCode;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \StructType\RefundFailureReasonType::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \StructType\RefundFailureReasonType
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RefundFailureReasonType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
